# a Panda Community Copy for observation...

# Panda3d Library: these sentences loads in the panda3d engine features from
# this script to load.this loads in mathamatical functions pi, sin, and cos
# which are trigonomic functions not standard in python.
# this loads the visual functions from panda3d into python.
from direct.showbase.ShowBase import ShowBase
# this loads the lighting functions from panda3d into python.
from panda3d.core import Filename, AmbientLight, DirectionalLight
# this loads camera funcations from panda3d into python
from panda3d.core import PandaNode, NodePath, Camera, TextNode
# this loads text functions from panda3d into python.
from direct.gui.OnscreenText import OnscreenText
# this loads the panda3d task manager into pyrhon.
from direct.task import Task
# this loads the animation funcations from panda3d into python.
from direct.actor.Actor import Actor
# this loads in other functions not included in this script.
import random
import sys
import os
import math

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Game
# - - -
# Load List: a filepath to a model is assigned to a interger (defined model)
scene1 = "Room/scenetest.egg"
actor1 = "Actor/charatest.egg"

# - - -
# Movment Varibles: used for features to track movement.
norpar = 0.0
nwpar = 0.0
wespar = 0.0
swpar = 0.0
soupar = 0.0
separ = 0.0
easpar = 0.0
nepar = 0.0
camrot = 0
CamPar = 0
zoomdel = 0
zmode = 0
vel = 0
facing = 0.0
IsJump = False
land = False
room = 0
vcolor = 0
# - - -
def debugtext(pos, msg):
    return OnscreenText(text=msg, style=1, fg=(1, 1, 1, 1), scale=.05, shadow=(0, 0, 0, 1), parent=base.a2dTopLeft, pos=(0.08, -pos - 0.04), align=TextNode.ALeft, mayChange=1)
    
# - - -
# Game System: controls all the logic for the game.
class gamesys(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)
        
# - Model (Visual) Functions -        
# Loads the model defined as the background environment, and reparents the model to
# render, finally sets the postion of the rendered background.
        self.scene = self.loader.loadModel(scene1)
        self.scene.reparentTo(self.render)
        self.scene.setPos(0, 0, 0)

# Loads the model defined as the player, then loads it's animation in the same
# line, it is then reparneted to render, finaly the animation is set to loop.
        self.pactor = Actor(actor1, {"Walk": "Actor/charatest-Walk"})
        self.pactor.reparentTo(self.render) 
        self.pactor.loop("Walk")
        self.pactor.setPos(0.0, 0.0, 0.0)
                        
# - Camera Functions -
# Disable the camera (default) trackball controls, and allows the camera to be
# moved around the player.
        self.disableMouse()
        self.camera.setPos(self.pactor.getX(), self.pactor.getY() + 10, 6)
        
# this creates a target for the cmaera to focus on.
        self.camtarget = NodePath(PandaNode("ctarget"))
        self.camtarget.reparentTo(self.pactor)
        self.camtarget.setZ(2.0)

# this determines the game's lighting
        ambientLight = AmbientLight("ambientLight")
        ambientLight.setColor((.3, .3, .3, 1))
        directionalLight = DirectionalLight("directionalLIght")
        directionalLight.setDirection((-5, -5, -5))
        directionalLight.setColor((1, 1, 1, 1))
        directionalLight.setSpecularColor((1, 1, 1, 1))
        render.setLight(render.attachNewNode(ambientLight))
        render.setLight(render.attachNewNode(directionalLight))

# - Control (Keyboard) Functions -
        self.keyMap = {"north": 0, "east": 0, "south": 0, "west": 0, "ishop": 0, "zoomin": 0, "zoomout": 0, "cambob": 0, "camweave": 0}

# keys when held down.       
        self.accept("arrow_up", self.satKey, ["north", True])
        self.accept("arrow_down", self.satKey, ["south", True])
        self.accept("arrow_left", self.satKey, ["west", True])
        self.accept("arrow_right", self.satKey, ["east", True])
        self.accept("j", self.satKey, ["ishop", True])
        self.accept("a", self.satKey, ["cambob", True])
        self.accept("d", self.satKey, ["camweave", True])
        self.accept("w", self.satKey, ["zoomin", True])
        self.accept("x", self.satKey, ["zoomout", True])        

# keys when released.        
        self.accept("arrow_up-up", self.satKey, ["north", False])
        self.accept("arrow_down-up", self.satKey, ["south", False])
        self.accept("arrow_left-up", self.satKey, ["west", False])
        self.accept("arrow_right-up", self.satKey, ["east", False])
        self.accept("j-up", self.satKey, ["ishop", False])
        self.accept("a-up", self.satKey, ["cambob", False])
        self.accept("d-up", self.satKey, ["camweave", False])
        self.accept("w-up", self.satKey, ["zoomin", False])
        self.accept("x-up", self.satKey, ["zoomout", False])

# these plays out whatever is defined (def) every frame.        
        self.taskMgr.add(self.move, "moveTask")
        self.taskMgr.add(self.fall, "gravityTask")
#        self.taskMgr.add(self.debug, "debugTask")

# defined functions for this class - - - - - - - - - - - - - - - - - - - - - -
    def satKey(self, key, value):
        self.keyMap[key] = value

    def move(self, task):
        dt = globalClock.getDt()
        global IsJump
        global land
        global facing
        global vel
        global camrot
        global norpar
        global nwpar
        global wespar
        global swpar
        global soupar
        global separ
        global easpar
        global nepar
            
# Camera Controls (for move) - - -     
# self.obejct within self.set object is the self.get for itself.
# standard roaming mode, as normal, tilted as zoomout

        if self.keyMap["cambob"]:            
             self.camera.setX(self.camera, -20 * dt)
        if self.keyMap["camweave"]:
             self.camera.setX(self.camera, +20 * dt)

        if self.keyMap["zoomin"]:
            if self.camera.getZ() > 2:
              self.camera.setZ(self.camera, -0.2)
        if self.keyMap["zoomout"]:
            if self.camera.getZ() < 16:
              self.camera.setZ(self.camera, +0.2)

            

# camvec is player's postion minus the camera's position or essentally the
# diffrence of the player's postion plus settting Z to 0, meaning only the
# X and Y diffrences or horizonal and verticals.
        camvec = self.pactor.getPos() - self.camera.getPos()
        camvec.setZ(0)
# camdist is the diaginal length between camvec's X and Y postions as a the
# missing trinagle piece.
        camdist = camvec.length()
# normalizes camvec's vector? (true if nomralize, false if zero-lentgh vector)       
        camvec.normalize()
        if camdist > 10.0:
             self.camera.setPos(self.camera.getPos() + camvec * (camdist -10))
             camdist = 10.0
        if camdist < 5.0:
             self.camera.setPos(self.camera.getPos() - camvec * (5 - camdist))
             camdist = 5.0
             

        if self.camera.getZ() < self.pactor.getZ() + 2.0:
            self.camera.setZ(self.pactor.getZ() + 2.0)

        self.camera.lookAt(self.camtarget)
        norpar = self.camera.getH() - 180.0
        nwpar = self.camera.getH() - 135.0
        wespar = self.camera.getH() - 90.0
        swpar = self.camera.getH() - 45.0
        soupar = self.camera.getH()
        separ = self.camera.getH() + 45.0
        easpar = self.camera.getH() + 90.0
        nepar = self.camera.getH() + 135.0
# 180 the normal for camera getH.

# Player Controls (for move) - - -
# this makes the player jump, by declaring the state of jumping as true and
# increasing the Z co-ord, when let go, the fall (gravity) function will kick
# in causing the player to fall back into place.
        if self.keyMap["ishop"]:
            if not land:
               if self.pactor.getZ() < 2.0:
                   IsJump = True
                   self.pactor.setZ(self.pactor, +5 * dt)
               else:
                   land = True
            else: IsJump = False       
                  
        else:
            IsJump = False
# when a player presses a buttion, the driection of that buttion becomes true
# as long as the press happens, a press results in the player's speed and
# movement going foward.

        if self.keyMap["north"] or self.keyMap["east"] or self.keyMap["south"] or self.keyMap["west"]:
           vel += 1          
           self.pactor.setY(self.pactor, -5 * dt)
# depedning on what direction is true (pessed/as long as pressed)  it asks if
# the player's speed is at a cetain point it tabs you to the target point, if
# not and not in the target point, it asks your are facing farthest or closest
# points each 45 degrees a part rightward of the target point, if so it tabs you
# to the target point if not, it asks if your facing farthest or closest points
# each 45 degrees apart leftward of the target point if so it tabs you to the
# target point. if not that, it asks if you are facing the points other then
# stated, if so, it cuts the player's speed to 0 forboding for the first "if"
# to come true. rotational map for H is below.
# (Plus +: Conter Clockwise)                (Minus -: Clockwise)  
#                      45.0      0.0     315.0
#                      90.0  <    ^    > 270.0
#                      135.0      v      225.0
#                               180.0

           if self.keyMap["north"]:
              if vel < 120:
                  facing = norpar
                  self.pactor.setH(facing)
              else:
                  facing = norpar
                  self.pactor.setH(facing)

                         
           if self.keyMap["west"]:
              if vel < 120:
                    facing = wespar                    
                    self.pactor.setH(facing)
              else:
                    facing = wespar
                    self.pactor.setH(facing)

           if self.keyMap["south"]:
              if vel < 120:
                    facing = soupar
                    self.pactor.setH(facing)
              else:
                    facing = soupar
                    self.pactor.setH(facing)                       
                         
           if self.keyMap["east"]:
              if vel < 120:
                    facing = easpar
                    self.pactor.setH(facing)
              else:      
                    facing = easpar
                    self.pactor.setH(facing)

           if self.keyMap["north"] and self.keyMap["east"]:
              if vel < 120:
                    facing = nepar
                    self.pactor.setH(facing)
              else:
                    facing = nepar
                    self.pactor.setH(facing)

           if self.keyMap["north"] and self.keyMap["west"]:
              if vel < 120:
                    facing = nwpar
                    self.pactor.setH(facing)
              else:
                    facing = nwpar
                    self.pactor.setH(facing)

           if self.keyMap["south"] and self.keyMap["east"]:
              if vel < 120:
                    facing = separ
                    self.pactor.setH(facing)
              else:
                    facing = separ
                    self.pactor.setH(facing)

           if self.keyMap["south"] and self.keyMap["west"]:
              if vel < 120:
                    facing = swpar
                    self.pactor.setH(facing)
              else:      
                    facing = swpar
                    self.pactor.setH(facing)
          

        else:
            if vel > 0:
              vel -= 1
              
        return Task.cont

    def fall(self, task):
        global IsJump
        global land
        dt = globalClock.getDt()
        if not IsJump:
            if self.pactor.getZ() > 0.0:
                self.pactor.setZ(self.pactor, -5 * dt)
            else:
                land = False

        return Task.cont        
# - Debugging Functions -
# The actual text functions for the debug list.

    def debug(self, task):
        global facing
        global room
        global vcolor
        line1 = "- DEBUG DISPLAY-"
        line2 = "VELOCITY:" + str(facing) 
        line3 = "DOOR:" + str(vel)
        line4 = "VERTEX COLOR:" + str(vcolor)
        line5 = "[N]: JUMP next"
        line6 = "[P]: JUMP prevous"
        
        self.debugline1 = debugtext(0.06, line1)
        self.debugline2 = debugtext(0.12, line2)
        self.debugline3 = debugtext(0.18, line3)
        self.debugline4 = debugtext(0.24, line4)        
        self.debugline5 = debugtext(0.30, line5)
        self.debugline6 = debugtext(0.36, line6)

#        self.debugline1.destroy()
#        self.debugline2.destroy()
#        self.debugline3.destroy()
#        self.debugline4.destroy()       
#        self.debugline5.destroy()
#        self.debugline6.destroy()
        
        return Task.cont
        
#this calls the preconstructed loop from panda3d engine instead of wrtting one.
app = gamesys ()
app.run()
# setP(X.X) = to tilt the model, setH(X.X) = rotates the model, setR(X.X) =
# pans the model in a pi (circle) degree angle.
# activate panda's placer mode
# def place (self):
#           base.startDirect(fWantTk = 1)
#           from direct.tkpanels import Placer
#           return Placer.place(self)
#------------------------------------------------------------------------------
# Python is basically using a calculator but you can label the numbers with a
# name, a number labeled under a name is called a “Integer”, now from the basic
# calculator commands there are additional ones that use names and other symbols
# for more manipulation, see command list below for their effects, a command can
# also be labeled just like a number, a command under a label is called a
# “Variable”, to label a number or command, you type in anything but a number
# alone, first, or a command name, then after that, a equal (=), then the number
# or command.

# Command List- - - - -

# = (equal sign): it does not do what it would do on a calculator, instead,
# whatever is after this becomes that of whatever is before this, if a number
# becomes a name, it is a integer, if a non number became a name, it is a
# variable,names cannot start with numbers but can end with numbers.

# + (Plus): addition with numbers labeled or not, but when dealing with commands
# label or not, it combines those commands involved, all each needing their own
# plus.

# - (Minus): subtraction with numbers labeled or not.

# * (Star, Multiply): does what the “X” on a calculator does, multiplication
# with numbers labeled or not.

# / (Slash, Division): does what the “Straight Percent Symbol” does on a
# calculator, division with numbers labeled or not.

# % (percent, modulus): it does not do what the percent would do on a calculator
# instead, it gives the difference from the division of a uneven division of
# numbers.

# print(): does what the equal (=) on a calculator does, and that is inject the
# “Result” of whatever is within the parentheses after this word into the
# standard output which is by default the console or screen (window).
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# script written by panda commuity user J.N. Pickee
